/* Video player application specific file */


#ifndef _FT_APP_PLAYVIDEO_H_
#define _FT_APP_PLAYVIDEO_H_




/* Software systems for ring buffer, queue */


/* Ring buffer implementation */

/* AVI parser design */
/*
 * heres the general layout of an AVI riff file (new format)
 *
 * RIFF (3F??????) AVI       <- not more than 1 GB in size
 *     LIST (size) hdrl
 *         avih (0038)
 *         LIST (size) strl
 *             strh (0038)
 *             strf (????)
 *             indx (3ff8)   <- size may vary, should be sector sized
 *         LIST (size) strl
 *             strh (0038)
 *             strf (????)
 *             indx (3ff8)   <- size may vary, should be sector sized
 *         LIST (size) odml
 *             dmlh (????)
 *         JUNK (size)       <- fill to align to sector - 12
 *     LIST (7f??????) movi  <- aligned on sector - 12
 *         00dc (size)       <- sector aligned
 *         01wb (size)       <- sector aligned
 *         ix00 (size)       <- sector aligned
 *     idx1 (00??????)       <- sector aligned
 * RIFF (7F??????) AVIX
 *     JUNK (size)           <- fill to align to sector -12
 *     LIST (size) movi
 *         00dc (size)       <- sector aligned
 * RIFF (7F??????) AVIX      <- not more than 2GB in size
 *     JUNK (size)           <- fill to align to sector - 12
 *     LIST (size) movi
 *         00dc (size)       <- sector aligned
 *
 *-===================================================================*/

/* return types of player */
typedef enum FT_AVIPLAYER_STATUS
{
	FT_AVIPLAYER_OK = 0,
}FT_AVIPLAYER_STATUS;

typedef enum FT_AVIPLAYER_FLAGS
{
	FT_AVIPLAYER_FLAGNONE = 0x00000000,
	FT_AVIPLAYER_MAXFPS = 0x00000001,
	FT_AVIPLAYER_MAXORG = 0x00000002,
}FT_AVIPLAYER_FLAGS;

/* AVI player state machine */
typedef enum FT_AVIPLAYER_STATE
{
	FT_AVIPLAYER_NONE = 0x00000001,
	FT_AVIPLAYER_INIT = 0x00000002,
	FT_AVIPLAYER_CONFIG = 0x00000004,
	FT_AVIPLAYER_SELECT = 0x00000008,
	FT_AVIPLAYER_PLAY = 0x00000010,
	FT_AVIPLAYER_PAUSE = 0x00000020,
	FT_AVIPLAYER_STOP = 0x00000040,
	FT_AVIPLAYER_EXIT = 0x00000080,
	FT_AVIPLAYER_SEEK = 0x00000100,
}FT_AVIPLAYER_STATE;

/* Context of AVI player */
typedef struct FT_AVIPlayer
{
	ft_uint32_t StateCurr;//none, init, configure, play, pause, stop, seek, exit
	ft_uint32_t StateNext;
	ft_uint32_t	AudioCodec;
	ft_uint32_t	VideoCodec;

	/* playback of a avi file context */
	ft_uint32_t	CurrTime;//time interms of ms and time wrt file playback - for pause this time is not changed
	ft_uint32_t TotalBytes;
}FT_AVIPlayer_t;

typedef enum FT_GUI_FLAGS
{
	FT_GUI_NONE = 0x00,
	FT_GUI_REFRESH = 0x01,
	FT_GUI_LINESWAP = 0x02,
	FT_GUI_PENDOWN = 0x04,

}FT_GUI_FLAGS;
typedef struct FT_PGUI
{
	ft_uint8_t PrevTTag;
	ft_uint8_t CurrTTag;
	ft_uint8_t TouchSel;
	ft_uint8_t VRateK;
	ft_uint8_t Flags;		//flags such as update gui,dlswap frame or line,
	ft_int32_t Disappear;	//offset of the touch point
}FT_PGUI_t;

typedef enum FT_VIDEO_ORIENTATION
{
	FT_VIDEO_LANDSCAPE=0,
	FT_VIDEO_INVERTED_LANDSCAPE,
	FT_VIDEO_PORTRAIT,
	FT_VIDEO_INVERTED_PORTRAIT,
	FT_VIDEO_MIRRORED_LANDSCAPE,
	FT_VIDEO_MIRRORED_INVERTED_LANDSCAPE,
	FT_VIDEO_MIRRORED_PORTRAIT,
	FT_VIDEO_MIRROED_INVERTED_PORTRAIT,
}FT_VIDEO_ORIENTATION;

typedef struct FT_GUI_BUTTONS_POS
{
	ft_int16_t playXPos;
	ft_int16_t playYPos;
	ft_uint8_t playWidth;
	ft_int16_t statusXPos;
	ft_int16_t statusYPos;
	ft_int16_t statusWidth;
	ft_int16_t exitXPos;
	ft_int16_t exitYPos;
	ft_int16_t exitWidth;
	ft_int16_t rotateXPos;
	ft_int16_t rotateYPos;
	ft_int16_t rotateWidth;
	ft_uint8_t buttonWidth;
	ft_uint8_t buttonHeight;
	ft_uint8_t buttonGap;
}FT_GUI_BUTTONS_POS;

typedef struct FT_VIDEO_FRAME
{
	ft_uint16_t frameWidth;
	ft_uint16_t frameHeight;
	ft_uint16_t finalFrameWidth;
	ft_uint16_t finalFrameHeight;
	ft_uint32_t scaleFactor;
	ft_uint8_t zoomOut;
	FT_VIDEO_ORIENTATION rotation;
	FT_GUI_BUTTONS_POS *controlButtons;
}FT_VIDEO_FRAME;

#define FT_VIDEO_TOUCH_THREASHOLD 4000



#if 0
/* GUI player context */
typedef struct FT_AVIP_Gui
{

}FT_AVIP_Gui_t;
#endif







#endif



